/*
	$Id$
*/

#include <SDL/SDL.h>

#include "taquin.h"
#include "draw.h"
#include "debug.h"

void Draw_grid(SDL_Surface *surface, SDL_PixelFormat *pixfmt)
{
	SDL_Rect MyRect;
	int i, j;

	for(i = 0; i< WIDTH; i += WIDTH/3)
	{
		for(j = 0; j < HEIGHT; j += HEIGHT/3)
		{
			/* top */
			MyRect.x = i;
			MyRect.y = j;
			MyRect.w = WIDTH/3;
			MyRect.h = 1;
			SDL_FillRect(surface, &MyRect, SDL_MapRGB(pixfmt, 0xff, 0xff, 0xff));

			/* left */
			MyRect.x = i;
			MyRect.y = j;
			MyRect.w = 1;
			MyRect.h = HEIGHT/3;
			SDL_FillRect(surface, &MyRect, SDL_MapRGB(pixfmt, 0xff, 0xff, 0xff));

			/* right */
			MyRect.x = i + WIDTH/3 - 1;
			MyRect.y = j + 1;
			MyRect.w = 1;
			MyRect.h = HEIGHT/3 - 1;
			SDL_FillRect(surface, &MyRect, SDL_MapRGB(pixfmt, 0x00, 0x00, 0x00));

			/* bottom */
			MyRect.x = i + 1;
			MyRect.y = j + HEIGHT/3 - 1;
			MyRect.w = HEIGHT/3 - 1;
			MyRect.h = 1;
			SDL_FillRect(surface, &MyRect, SDL_MapRGB(pixfmt, 0x00, 0x00, 0x00));
		}
	}
}

void Draw_game(struct Taquin *taquin, int x, int y)
{
	SDL_FillRect(taquin->surface, NULL, 0);
	SDL_BlitSurface(taquin->back, NULL, taquin->surface, NULL);

	{
		int i, j;
		SDL_Rect src, dst;

		for(i=0; i<9; i++)
		{
			if(i != (x+y*3))
			{
				j = taquin->grid[i];
				src.x = WIDTH/3 * (j-(j/3)*3);
				src.y = HEIGHT/3 * (j/3);
				src.w = WIDTH/3;
				src.h = HEIGHT/3;
				DEBUG("src -> x : %d, y : %d\n", src.x, src.y);

				dst.x = WIDTH/3 * (i-(i/3)*3);
				dst.y = HEIGHT/3 * (i/3);
				dst.w = WIDTH/3;
				dst.h = HEIGHT/3;
				DEBUG("dst -> x : %d, y : %d\n", dst.x, dst.y);

				SDL_BlitSurface(taquin->image, &src, taquin->surface, &dst);
			}
		}
	}

	SDL_Flip(taquin->surface);
}

